/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
	"time"
)

// checks if the InteractionWithMetrics type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &InteractionWithMetrics{}

// InteractionWithMetrics struct for InteractionWithMetrics
type InteractionWithMetrics struct {
	Id string `json:"id"`
	ChannelId string `json:"channel_id"`
	OrganizationId string `json:"organization_id"`
	Name string `json:"name"`
	TriggerTemplate string `json:"trigger_template"`
	State State `json:"state"`
	LiveFrom *time.Time `json:"live_from,omitempty"`
	LiveTo *time.Time `json:"live_to,omitempty"`
	Languages []string `json:"languages,omitempty"`
	Messengers []string `json:"messengers,omitempty"`
	Tags []string `json:"tags,omitempty"`
	Interactions int32 `json:"interactions"`
	UniqueContacts int32 `json:"unique_contacts"`
	Consents int32 `json:"consents"`
	ChatsStarted int32 `json:"chats_started"`
	MainActions int32 `json:"main_actions"`
	Investments int32 `json:"investments"`
}

// NewInteractionWithMetrics instantiates a new InteractionWithMetrics object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewInteractionWithMetrics(id string, channelId string, organizationId string, name string, triggerTemplate string, state State, interactions int32, uniqueContacts int32, consents int32, chatsStarted int32, mainActions int32, investments int32) *InteractionWithMetrics {
	this := InteractionWithMetrics{}
	this.Id = id
	this.ChannelId = channelId
	this.OrganizationId = organizationId
	this.Name = name
	this.TriggerTemplate = triggerTemplate
	this.State = state
	this.Interactions = interactions
	this.UniqueContacts = uniqueContacts
	this.Consents = consents
	this.ChatsStarted = chatsStarted
	this.MainActions = mainActions
	this.Investments = investments
	return &this
}

// NewInteractionWithMetricsWithDefaults instantiates a new InteractionWithMetrics object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewInteractionWithMetricsWithDefaults() *InteractionWithMetrics {
	this := InteractionWithMetrics{}
	return &this
}

// GetId returns the Id field value
func (o *InteractionWithMetrics) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *InteractionWithMetrics) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *InteractionWithMetrics) SetId(v string) {
	o.Id = v
}

// GetChannelId returns the ChannelId field value
func (o *InteractionWithMetrics) GetChannelId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value
// and a boolean to check if the value has been set.
func (o *InteractionWithMetrics) GetChannelIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ChannelId, true
}

// SetChannelId sets field value
func (o *InteractionWithMetrics) SetChannelId(v string) {
	o.ChannelId = v
}

// GetOrganizationId returns the OrganizationId field value
func (o *InteractionWithMetrics) GetOrganizationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value
// and a boolean to check if the value has been set.
func (o *InteractionWithMetrics) GetOrganizationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OrganizationId, true
}

// SetOrganizationId sets field value
func (o *InteractionWithMetrics) SetOrganizationId(v string) {
	o.OrganizationId = v
}

// GetName returns the Name field value
func (o *InteractionWithMetrics) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *InteractionWithMetrics) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *InteractionWithMetrics) SetName(v string) {
	o.Name = v
}

// GetTriggerTemplate returns the TriggerTemplate field value
func (o *InteractionWithMetrics) GetTriggerTemplate() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.TriggerTemplate
}

// GetTriggerTemplateOk returns a tuple with the TriggerTemplate field value
// and a boolean to check if the value has been set.
func (o *InteractionWithMetrics) GetTriggerTemplateOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TriggerTemplate, true
}

// SetTriggerTemplate sets field value
func (o *InteractionWithMetrics) SetTriggerTemplate(v string) {
	o.TriggerTemplate = v
}

// GetState returns the State field value
func (o *InteractionWithMetrics) GetState() State {
	if o == nil {
		var ret State
		return ret
	}

	return o.State
}

// GetStateOk returns a tuple with the State field value
// and a boolean to check if the value has been set.
func (o *InteractionWithMetrics) GetStateOk() (*State, bool) {
	if o == nil {
		return nil, false
	}
	return &o.State, true
}

// SetState sets field value
func (o *InteractionWithMetrics) SetState(v State) {
	o.State = v
}

// GetLiveFrom returns the LiveFrom field value if set, zero value otherwise.
func (o *InteractionWithMetrics) GetLiveFrom() time.Time {
	if o == nil || IsNil(o.LiveFrom) {
		var ret time.Time
		return ret
	}
	return *o.LiveFrom
}

// GetLiveFromOk returns a tuple with the LiveFrom field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *InteractionWithMetrics) GetLiveFromOk() (*time.Time, bool) {
	if o == nil || IsNil(o.LiveFrom) {
		return nil, false
	}
	return o.LiveFrom, true
}

// HasLiveFrom returns a boolean if a field has been set.
func (o *InteractionWithMetrics) HasLiveFrom() bool {
	if o != nil && !IsNil(o.LiveFrom) {
		return true
	}

	return false
}

// SetLiveFrom gets a reference to the given time.Time and assigns it to the LiveFrom field.
func (o *InteractionWithMetrics) SetLiveFrom(v time.Time) {
	o.LiveFrom = &v
}

// GetLiveTo returns the LiveTo field value if set, zero value otherwise.
func (o *InteractionWithMetrics) GetLiveTo() time.Time {
	if o == nil || IsNil(o.LiveTo) {
		var ret time.Time
		return ret
	}
	return *o.LiveTo
}

// GetLiveToOk returns a tuple with the LiveTo field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *InteractionWithMetrics) GetLiveToOk() (*time.Time, bool) {
	if o == nil || IsNil(o.LiveTo) {
		return nil, false
	}
	return o.LiveTo, true
}

// HasLiveTo returns a boolean if a field has been set.
func (o *InteractionWithMetrics) HasLiveTo() bool {
	if o != nil && !IsNil(o.LiveTo) {
		return true
	}

	return false
}

// SetLiveTo gets a reference to the given time.Time and assigns it to the LiveTo field.
func (o *InteractionWithMetrics) SetLiveTo(v time.Time) {
	o.LiveTo = &v
}

// GetLanguages returns the Languages field value if set, zero value otherwise.
func (o *InteractionWithMetrics) GetLanguages() []string {
	if o == nil || IsNil(o.Languages) {
		var ret []string
		return ret
	}
	return o.Languages
}

// GetLanguagesOk returns a tuple with the Languages field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *InteractionWithMetrics) GetLanguagesOk() ([]string, bool) {
	if o == nil || IsNil(o.Languages) {
		return nil, false
	}
	return o.Languages, true
}

// HasLanguages returns a boolean if a field has been set.
func (o *InteractionWithMetrics) HasLanguages() bool {
	if o != nil && !IsNil(o.Languages) {
		return true
	}

	return false
}

// SetLanguages gets a reference to the given []string and assigns it to the Languages field.
func (o *InteractionWithMetrics) SetLanguages(v []string) {
	o.Languages = v
}

// GetMessengers returns the Messengers field value if set, zero value otherwise.
func (o *InteractionWithMetrics) GetMessengers() []string {
	if o == nil || IsNil(o.Messengers) {
		var ret []string
		return ret
	}
	return o.Messengers
}

// GetMessengersOk returns a tuple with the Messengers field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *InteractionWithMetrics) GetMessengersOk() ([]string, bool) {
	if o == nil || IsNil(o.Messengers) {
		return nil, false
	}
	return o.Messengers, true
}

// HasMessengers returns a boolean if a field has been set.
func (o *InteractionWithMetrics) HasMessengers() bool {
	if o != nil && !IsNil(o.Messengers) {
		return true
	}

	return false
}

// SetMessengers gets a reference to the given []string and assigns it to the Messengers field.
func (o *InteractionWithMetrics) SetMessengers(v []string) {
	o.Messengers = v
}

// GetTags returns the Tags field value if set, zero value otherwise.
func (o *InteractionWithMetrics) GetTags() []string {
	if o == nil || IsNil(o.Tags) {
		var ret []string
		return ret
	}
	return o.Tags
}

// GetTagsOk returns a tuple with the Tags field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *InteractionWithMetrics) GetTagsOk() ([]string, bool) {
	if o == nil || IsNil(o.Tags) {
		return nil, false
	}
	return o.Tags, true
}

// HasTags returns a boolean if a field has been set.
func (o *InteractionWithMetrics) HasTags() bool {
	if o != nil && !IsNil(o.Tags) {
		return true
	}

	return false
}

// SetTags gets a reference to the given []string and assigns it to the Tags field.
func (o *InteractionWithMetrics) SetTags(v []string) {
	o.Tags = v
}

// GetInteractions returns the Interactions field value
func (o *InteractionWithMetrics) GetInteractions() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Interactions
}

// GetInteractionsOk returns a tuple with the Interactions field value
// and a boolean to check if the value has been set.
func (o *InteractionWithMetrics) GetInteractionsOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Interactions, true
}

// SetInteractions sets field value
func (o *InteractionWithMetrics) SetInteractions(v int32) {
	o.Interactions = v
}

// GetUniqueContacts returns the UniqueContacts field value
func (o *InteractionWithMetrics) GetUniqueContacts() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.UniqueContacts
}

// GetUniqueContactsOk returns a tuple with the UniqueContacts field value
// and a boolean to check if the value has been set.
func (o *InteractionWithMetrics) GetUniqueContactsOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.UniqueContacts, true
}

// SetUniqueContacts sets field value
func (o *InteractionWithMetrics) SetUniqueContacts(v int32) {
	o.UniqueContacts = v
}

// GetConsents returns the Consents field value
func (o *InteractionWithMetrics) GetConsents() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Consents
}

// GetConsentsOk returns a tuple with the Consents field value
// and a boolean to check if the value has been set.
func (o *InteractionWithMetrics) GetConsentsOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Consents, true
}

// SetConsents sets field value
func (o *InteractionWithMetrics) SetConsents(v int32) {
	o.Consents = v
}

// GetChatsStarted returns the ChatsStarted field value
func (o *InteractionWithMetrics) GetChatsStarted() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.ChatsStarted
}

// GetChatsStartedOk returns a tuple with the ChatsStarted field value
// and a boolean to check if the value has been set.
func (o *InteractionWithMetrics) GetChatsStartedOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ChatsStarted, true
}

// SetChatsStarted sets field value
func (o *InteractionWithMetrics) SetChatsStarted(v int32) {
	o.ChatsStarted = v
}

// GetMainActions returns the MainActions field value
func (o *InteractionWithMetrics) GetMainActions() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.MainActions
}

// GetMainActionsOk returns a tuple with the MainActions field value
// and a boolean to check if the value has been set.
func (o *InteractionWithMetrics) GetMainActionsOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.MainActions, true
}

// SetMainActions sets field value
func (o *InteractionWithMetrics) SetMainActions(v int32) {
	o.MainActions = v
}

// GetInvestments returns the Investments field value
func (o *InteractionWithMetrics) GetInvestments() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Investments
}

// GetInvestmentsOk returns a tuple with the Investments field value
// and a boolean to check if the value has been set.
func (o *InteractionWithMetrics) GetInvestmentsOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Investments, true
}

// SetInvestments sets field value
func (o *InteractionWithMetrics) SetInvestments(v int32) {
	o.Investments = v
}

func (o InteractionWithMetrics) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o InteractionWithMetrics) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	toSerialize["channel_id"] = o.ChannelId
	toSerialize["organization_id"] = o.OrganizationId
	toSerialize["name"] = o.Name
	toSerialize["trigger_template"] = o.TriggerTemplate
	toSerialize["state"] = o.State
	if !IsNil(o.LiveFrom) {
		toSerialize["live_from"] = o.LiveFrom
	}
	if !IsNil(o.LiveTo) {
		toSerialize["live_to"] = o.LiveTo
	}
	if !IsNil(o.Languages) {
		toSerialize["languages"] = o.Languages
	}
	if !IsNil(o.Messengers) {
		toSerialize["messengers"] = o.Messengers
	}
	if !IsNil(o.Tags) {
		toSerialize["tags"] = o.Tags
	}
	toSerialize["interactions"] = o.Interactions
	toSerialize["unique_contacts"] = o.UniqueContacts
	toSerialize["consents"] = o.Consents
	toSerialize["chats_started"] = o.ChatsStarted
	toSerialize["main_actions"] = o.MainActions
	toSerialize["investments"] = o.Investments
	return toSerialize, nil
}

type NullableInteractionWithMetrics struct {
	value *InteractionWithMetrics
	isSet bool
}

func (v NullableInteractionWithMetrics) Get() *InteractionWithMetrics {
	return v.value
}

func (v *NullableInteractionWithMetrics) Set(val *InteractionWithMetrics) {
	v.value = val
	v.isSet = true
}

func (v NullableInteractionWithMetrics) IsSet() bool {
	return v.isSet
}

func (v *NullableInteractionWithMetrics) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableInteractionWithMetrics(val *InteractionWithMetrics) *NullableInteractionWithMetrics {
	return &NullableInteractionWithMetrics{value: val, isSet: true}
}

func (v NullableInteractionWithMetrics) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableInteractionWithMetrics) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


